import React from 'react';
import $ from 'jquery/src/ajax';
import 'react-quill/dist/quill.bubble.css';
import moment from 'moment';
import {Form,Icon,Button,Input,Select,Spin,Table,message,DatePicker,Modal,Upload,Popconfirm,Cascader,InputNumber,Radio,TimePicker,Tabs} from 'antd';
import {areaSelect, getProvince} from '@/NewDicProvinceList';//省市区
import { getGameState, splitUrl, getprovince, getStatuslist, getLvl,beforeUploadFile,getSecretType,getBuyAuditType} from '@/tools.js';
const PicturesWall = React.createClass({
    getInitialState() {
        return {
            previewVisible: false,
            previewImage: '',
            fileList: this.props.pictureUrl,
        }
    },
    getDefaultProps(){
    	return{
    		changeClick:this.modifyChange
    	}
    },
    handleCancel() {
        this.setState({ previewVisible: false })
    },
    handlePreview(file) {
        this.setState({
            previewImage: file.url || file.thumbUrl,
            previewVisible: true,
        });
    },
    handleChange(info) {
        let fileList = info.fileList;
        this.setState({ fileList });
        this.props.fileList(fileList);
    },
    componentWillReceiveProps(nextProps) {
        this.state.fileList = nextProps.pictureUrl; 
    },
    render() {
        const { previewVisible, previewImage, fileList } = this.state;
        const uploadButton = (
            <div>
                <Icon type="plus" />
                <div className="ant-upload-text">点击上传</div>
            </div>
        );
        return (
            <div style={{display:"inline-block"}}>
                <Upload
                	beforeUpload={beforeUploadFile}
                    action={globalConfig.context + "/api/admin/purchase/uploadPicture"}
                    data={{ 'sign': 'purchase_picture' }}
                    listType="picture-card"
                    fileList={fileList}
                    onPreview={this.handlePreview}
                    onChange={this.handleChange} >
					{fileList.length >= 18 ? null : uploadButton}
                </Upload>
                <Modal maskClosable={false} visible={previewVisible} footer={null} onCancel={this.handleCancel}>
                    <img alt="example" style={{ width: '100%' }} src={previewImage} />
                </Modal>
            </div>
        );
    }
});
//主体
const CheckBuy = Form.create()(
	React.createClass({
		loadData(pageNo) {
			this.state.data = [];
			this.setState({
				loading: true,
				page: pageNo
			});
			$.ajax({
				method: 'get',
				dataType: 'json',
				crossDomain: false,
				url: globalConfig.context + '/api/admin/purchase/listPurchase',
				data: {
					pageNo: pageNo || 1,
					pageSize: this.state.pagination.pageSize,
					auditStatus: 1,
				},
				success: function(data) {
					let theArr = [];
					if (!data.data || !data.data.list) {
						if (data.error && data.error.length) {
							message.warning(data.error[0].message);
						}
					} else {
						for (let i = 0; i < data.data.list.length; i++) {
							let thisdata = data.data.list[i];
							theArr.push({
								key: i,
								id: thisdata.id,
								title: thisdata.title,
								type: thisdata.type,
								secretType: thisdata.secretType,
								auditStatus: thisdata.auditStatus,
								topNumber: thisdata.topNumber,
								sortNumber: thisdata.sortNumber,
								home: thisdata.home,
								contacts: thisdata.contacts,
								contactsMobile:thisdata.contactsMobile,
								orgName:thisdata.orgName,
								endTimes:thisdata.endTimes,
								releaseDates:thisdata.releaseDates,
								userName:thisdata.userName,
								releaseStatus:thisdata.releaseStatus,
							});
						}
						this.state.pagination.current = data.data.pageNo;
						this.state.pagination.total = data.data.totalCount;
					}
					this.setState({
						dataSource: theArr,
						pagination: this.state.pagination
					});
				}.bind(this)
			}).always(
				function() {
					this.setState({
						loading: false
					});
				}.bind(this)
			);
		},
		getInitialState() {
			return {
				loading: false,
				flag: true,
				timesArr:[],
				totalData:{
					mark: false,
				},
				purchaseImg: [],
				pagination: {
					defaultCurrent: 1,
					defaultPageSize: 10,
					showQuickJumper: true,
					pageSize: 10,
					onChange: function(page) {
						this.loadData(page);
						this.setState({
							selectedRowKeys: []
						});
					}.bind(this),
					showTotal: function(total) {
						return '共' + total + '条数据';
					}
				},
				columns: [
					{
						title: '序号',
						dataIndex: 'key',
						key: 'key'
					},
					{
						title: '标题',
						dataIndex: 'title',
						key: 'title'
					},
					{
						title: '信息栏目',
						dataIndex: 'type',
						key: 'type',
						render:text=>{
							return text === 0?'中标公司':'投标公司'
						}
					},
					{
						title: '密级',
						dataIndex: 'secretType',
						key: 'secretType',
						render:(text)=>{
							return getSecretType(text);
						}
					},
					{
						title: '有限时限',
						dataIndex: 'endTimes',
						key: 'endTimes',
						width: 200,
					},
					{
						title: '发布时间',
						dataIndex: 'releaseDates',
						key: 'releaseDates',
						width: 200,
					},
					{
						title: '发布人',
						dataIndex: 'userName',
						key: 'userName',
					},
					{
						title: '排序',
						dataIndex: 'sortNumber',
						key: 'sortNumber'
					},
					{
						title: '发布状态',
						dataIndex: 'releaseStatus',
						key: 'releaseStatus',
						render:text=>{
							return text?'已发布':'未发布';
						}
					},
					{
						title: '审核状态',
						dataIndex: 'auditStatus',
						key: 'auditStatus',
						render:text=>{
							return getBuyAuditType(text);
						}
					},
					{
						title: '置顶',
						dataIndex: 'topNumber',
						key: 'topNumber',
						render:(text)=>{
							return text?'否':'是';
						}
					},
					{
						title: '操作',
						dataIndex: 'ads',
						key: 'ads',
						render:(text,record,index)=>{
							return  <div>
										{<Button type="primary" onClick={(event)=>{
											this.stopPropagation(event)
											this.tableRowClick(record)
										}}>修改</Button>}
										{<Popconfirm okText="确定" cancelText="取消" title="是否确认删除？" onConfirm={()=>{
											this.delete(record.id)
										}}>
											<Button type="primary" style={{marginLeft:"10px"}} onClick={(event)=>{
												this.stopPropagation(event)
											}}>删除</Button>
										</Popconfirm>}
									</div>
						}
					},
				],
				dataSource: []
			};
		},
		
		componentWillMount() {
			this.loadData()
		},
		detailes(record) {
			this.setState({
				loading:true
			});
			$.ajax({
				method: 'get',
				dataType: 'json',
				crossDomain: false,
				url: globalConfig.context + '/api/admin/purchase/details',
				data: {
					id: record.id,
				},
				success: function(data) {
					let theArr = [];
					let thisdata = data.data;
					if (!data.data || !data.data.list) {
						if (data.error && data.error.length) {
							message.warning(data.error[0].message);
						}
					}
					this.setState({
						purchaseImg: thisdata.purchaseImg ? splitUrl(thisdata.purchaseImg, ',', globalConfig.avatarHost + '/upload') : [],
					})
					Object.assign(this.state.totalData,{
						content: thisdata.content,
					},this.state.RowData)
				}.bind(this)
			}).always(
				function() {
					this.setState({
						loading: false
					});
				}.bind(this)
			);
		},
		
		stopPropagation(e){
			e.stopPropagation();
			e.nativeEvent.stopImmediatePropagation();
		},
		
		//项目列表整行点击
		tableRowClick(record, index) {
			this.state.RowData = record;
			this.setState({
				editvisible: true,
			});
			this.detailes(record);
		},
		
		edithandleCancel(e) {
			this.setState({
				editvisible: false
			},()=>{
				this.addReset()
			});
			this.loadData()
		},
		
		search() {
			this.loadData();
		},
		
		add(){
			this.setState({
				editvisible: true,
				flag: false,
			});
		},
		addNew(){
			let theorgCodeUrl = [];
			if (this.state.purchaseImg.length) {
			    let picArr = [];
			    this.state.purchaseImg.map(function (item) {
					if ( item.response && item.response.data && item.response.data.length ){
						picArr.push(item.response.data);
					}
			    });
			    theorgCodeUrl = picArr.join(",");
			};
			this.setState({
				loading:true
			});
			
			if(theorgCodeUrl.length){
				this.change("purchaseImg",theorgCodeUrl)
			}else{
				this.change("purchaseImg",[])
			}
			$.ajax({
				method: 'post',
				dataType: 'json',
				crossDomain: false,
				url: (this.state.flag?'/api/admin/purchase/updateAudit':'/api/admin/purchase/apply'),
				data: this.state.totalData,
			}).done(function(data) {
			this.setState({
				loading: false
			});
			if(!data.error.length) {
				message.success('保存成功！');
				this.setState({
					editvisible:false,
					flag:true
				})
				this.addReset()
				this.loadData()
			} else {
				message.warning(data.error[0].message);
			}
		}.bind(this));
		},
		
		saveNew(){
			this.change("auditStatus",2,()=>{
				this.addNew()
			})
		},
		
		issueNew(){
			this.change("auditStatus",2)
			this.change("releaseStatus",1,()=>{
				this.addNew()
			})
		},
		
		reject(){
			this.change("home",undefined)
			this.change("auditStatus",3,()=>{
				this.addNew()
			})
		},
		
		delete(id){
			this.setState({
					loading:true
				});
				$.ajax({
					method: 'post',
					dataType: 'json',
					crossDomain: false,
					url: "/api/admin/purchase/delete",
					data: {
						id: id,
					},
				}).done(function(data) {
				this.setState({
					loading: false
				});
				if(!data.error.length) {
					message.success('删除成功！');
					this.loadData()
				} else {
					message.warning(data.error[0].message);
				}
			}.bind(this));
		},
		
		cancelAdd(){
			this.setState({
				editvisible: false,
			},()=>{
				this.setState({
					flag:true
				})
				this.addReset()
			});
			this.loadData()
		},
		
		//新增框的清零
		addReset(){
			this.setState({
				totalData:{},
				purchaseImg:[],
			})
		},
		//搜索部分的清零
		reset() {
			this.setState({
				auditStatusSearch: undefined,
				typeSearch: undefined,
				secretTypeSearch: undefined,
				titleSearch: undefined,
			})
			this.loadData();
		},
		getOrgCodeUrl(e) {
		    this.setState({ purchaseImg: e });
		},
		
		change(key, e, f){
			if(f === undefined ){
				this.state.totalData[key] = e
				this.setState({
					totalData:this.state.totalData
				})
			}else if(typeof(f) === "function"){
				this.state.totalData[key] = e
				this.setState({
					totalData:this.state.totalData
				},f)
			}
		},
		
		render() {
			const FormItem = Form.Item;
			const rowSelection = {
				selectedRowKeys: this.state.selectedRowKeys,
				onChange: (selectedRowKeys, selectedRows) => {
					this.setState({
						selectedRows: selectedRows.slice(-1),
						selectedRowKeys: selectedRowKeys.slice(-1)
					});
				}
			};
			let data = this.state.totalData;
			const { TextArea } = Input;//文本域
			const { TabPane } = Tabs;//标签页
			const { MonthPicker, RangePicker, WeekPicker } = DatePicker;//日期输入框
			return (
				<div className="user-content">
					<div className="content-title">
						<span>采购审核列表</span>
						<div className="user-search">
							<Input
								placeholder="企业名称"
								style={{ width: '150px', marginRight: '10px', marginBottom: '10px' }}
								value={this.state.nameSearch}
								onChange={(e) => {
									this.setState({ nameSearch: e.target.value });
								}}
							/>
							<Button type="primary" onClick={this.search} style={{ marginRight: '10px' }}>
								搜索
							</Button>
							<Button onClick={this.reset} style={{ marginRight: '10px' }}>
								重置
							</Button>
							{/*<Button type="primary" onClick={this.add} style={{ marginLeft: '100px'}}>
								新增采购审核
							</Button>*/}
						</div>
						<div className="patent-table">
							<Spin spinning={this.state.loading}>
								<Table
									columns={this.state.columns}
									dataSource={this.state.dataSource}
									pagination={this.state.pagination}
									onRowClick={this.tableRowClick}
								/>
							</Spin>
						</div>
					</div>
					<div className="patent-desc">
						<Modal
							className="customeDetails"
							title={this.state.flag?'采购审核详情':'新增采购审核'}
							width="500px"
							visible={this.state.editvisible}
							onOk={this.edithandleCancel}
							onCancel={this.state.flag?this.edithandleCancel:this.cancelAdd}
							footer=""
						>
							<Form layout="horizontal" onSubmit={this.edithandleSubmit} id="demand-form">
								<Spin spinning={this.state.loading}>
									<div className="clearfix">
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="是否首页"
										>
											<Radio.Group onChange={(e)=>{
												this.change('home',e.target.value)
											}} value={data.home}>
												<Radio value={0}>是</Radio>
												<Radio value={1}>否</Radio>
											</Radio.Group>
										</FormItem>
									</div>	
										<div className="clearfix" style={{marginTop:'40px'}}>
											{/*<Button type="primary" size="large" onClick={this.addNew} style={{float:'right',marginRight:'80px',marginTop:'20px'}}>保存</Button>
											<Button type="primary" size="large" onClick={this.issueNew} style={{float:'right',marginRight:'20px',marginTop:'20px'}}>保存并发布</Button>*/}
											<Button type="primary" size="large" style={{float:"left",marginRight:'40px',marginTop:'20px'}} onClick={this.saveNew}>审核通过</Button>
											<Button type="primary" size="large" style={{float:"left",marginRight:'40px',marginTop:'20px'}} onClick={this.issueNew}>审核通过并发布</Button>
											<Button type="danger" size="large" style={{float:"left",marginRight:'40px',marginTop:'20px'}} onClick={this.reject}>驳回</Button>
										</div>
								</Spin>
							</Form>
						</Modal>
					</div>
				</div>
			);
		}
	})
);

export default CheckBuy;
